Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs	(revision 15017)
@@ -27,5 +27,5 @@
       var result = second + first;
 
-      interpreter.IntegerStack.SetTop(result);
+      interpreter.IntegerStack.Top = result;
     }
   }
@@ -50,5 +50,5 @@
       var result = second - first;
 
-      interpreter.IntegerStack.SetTop(result);
+      interpreter.IntegerStack.Top = result;
     }
   }
@@ -73,5 +73,5 @@
       var result = second * first;
 
-      interpreter.IntegerStack.SetTop(result);
+      interpreter.IntegerStack.Top = result;
     }
   }
@@ -97,5 +97,5 @@
       var result = second / first;
 
-      interpreter.IntegerStack.SetTop(result);
+      interpreter.IntegerStack.Top = result;
     }
   }
@@ -123,5 +123,5 @@
       var result = second % first;
 
-      interpreter.IntegerStack.SetTop(result);
+      interpreter.IntegerStack.Top = result;
     }
   }
@@ -146,5 +146,5 @@
       var result = Math.Min(second, first);
 
-      interpreter.IntegerStack.SetTop(result);
+      interpreter.IntegerStack.Top = result;
     }
   }
@@ -169,5 +169,5 @@
       var result = Math.Max(second, first);
 
-      interpreter.IntegerStack.SetTop(result);
+      interpreter.IntegerStack.Top = result;
     }
   }
@@ -198,12 +198,12 @@
 
   /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the second item is greater than the top item, or FALSE otherwise.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.>", StackTypes.Boolean)]
-  [StorableClass]
-  public class IntegerGreaterThanExpression : StatelessExpression {
-    public IntegerGreaterThanExpression() { }
-    [StorableConstructor]
-    protected IntegerGreaterThanExpression(bool deserializing) : base(deserializing) { }
+  ///     Pushes TRUE onto the BOOLEAN stack if the second item is less than or equal to the top item, or FALSE otherwise.
+  /// </summary>
+  [PushExpression(StackTypes.Integer, "INTEGER.<=", StackTypes.Boolean)]
+  [StorableClass]
+  public class IntegerSmallerOrEqualToExpression : StatelessExpression {
+    public IntegerSmallerOrEqualToExpression() { }
+    [StorableConstructor]
+    protected IntegerSmallerOrEqualToExpression(bool deserializing) : base(deserializing) { }
 
     public override bool IsNoop(IInternalPushInterpreter interpreter) {
@@ -216,5 +216,54 @@
       interpreter.IntegerStack.Remove(2);
 
+      var result = second <= first;
+      interpreter.BooleanStack.Push(result);
+    }
+  }
+
+  /// <summary>
+  ///     Pushes TRUE onto the BOOLEAN stack if the second item is greater than the top item, or FALSE otherwise.
+  /// </summary>
+  [PushExpression(StackTypes.Integer, "INTEGER.>", StackTypes.Boolean)]
+  [StorableClass]
+  public class IntegerGreaterThanExpression : StatelessExpression {
+    public IntegerGreaterThanExpression() { }
+    [StorableConstructor]
+    protected IntegerGreaterThanExpression(bool deserializing) : base(deserializing) { }
+
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      return interpreter.IntegerStack.Count < 2;
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      var first = interpreter.IntegerStack.Top;
+      var second = interpreter.IntegerStack[1];
+      interpreter.IntegerStack.Remove(2);
+
       var result = second > first;
+      interpreter.BooleanStack.Push(result);
+    }
+  }
+
+
+  /// <summary>
+  ///     Pushes TRUE onto the BOOLEAN stack if the second item is greater than or equal to the top item, or FALSE otherwise.
+  /// </summary>
+  [PushExpression(StackTypes.Integer, "INTEGER.>=", StackTypes.Boolean)]
+  [StorableClass]
+  public class IntegerGreaterOrEqualToExpression : StatelessExpression {
+    public IntegerGreaterOrEqualToExpression() { }
+    [StorableConstructor]
+    protected IntegerGreaterOrEqualToExpression(bool deserializing) : base(deserializing) { }
+
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      return interpreter.IntegerStack.Count < 2;
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      var first = interpreter.IntegerStack.Top;
+      var second = interpreter.IntegerStack[1];
+      interpreter.IntegerStack.Remove(2);
+
+      var result = second >= first;
       interpreter.BooleanStack.Push(result);
     }
@@ -257,7 +306,90 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      var value = (int)interpreter.FloatStack.Pop();
+      var value = (long)(interpreter.FloatStack.Pop());
       interpreter.IntegerStack.Push(value);
     }
   }
+
+  /// <summary>
+  ///     Pushes the result of truncating the top CHAR.
+  /// </summary>
+  [PushExpression(StackTypes.Integer, "INTEGER.FROMCHAR", StackTypes.Char)]
+  [StorableClass]
+  public class IntegerFromCharExpression : StatelessExpression {
+    public IntegerFromCharExpression() { }
+    [StorableConstructor]
+    protected IntegerFromCharExpression(bool deserializing) : base(deserializing) { }
+
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      return interpreter.CharStack.IsEmpty;
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      var value = interpreter.CharStack.Pop();
+      interpreter.IntegerStack.Push(value);
+    }
+  }
+
+  /// <summary>
+  ///     Pushes the result of parsing the top STRING.
+  /// </summary>
+  [PushExpression(StackTypes.Integer, "INTEGER.FROMSTRING", StackTypes.String)]
+  [StorableClass]
+  public class IntegerFromStringExpression : StatelessExpression {
+    public IntegerFromStringExpression() { }
+    [StorableConstructor]
+    protected IntegerFromStringExpression(bool deserializing) : base(deserializing) { }
+
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      long tmp;
+
+      return interpreter.StringStack.IsEmpty ||
+             interpreter.StringStack.Top.Length == 0 ||
+             !long.TryParse(interpreter.StringStack.Top, out tmp);
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      var str = interpreter.StringStack.Pop();
+      var value = long.Parse(str);
+      interpreter.IntegerStack.Push(value);
+    }
+  }
+
+  /// <summary>
+  ///     Pushes the result of increasing the top INTEGER by 1.
+  /// </summary>
+  [PushExpression(StackTypes.Integer, "INTEGER.INC")]
+  [StorableClass]
+  public class IntegerIncExpression : StatelessExpression {
+    public IntegerIncExpression() { }
+    [StorableConstructor]
+    protected IntegerIncExpression(bool deserializing) : base(deserializing) { }
+
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      return interpreter.IntegerStack.IsEmpty;
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      interpreter.IntegerStack.Top += 1;
+    }
+  }
+
+  /// <summary>
+  ///     Pushes the result of decreasing the top INTEGER by 1.
+  /// </summary>
+  [PushExpression(StackTypes.Integer, "INTEGER.DEC")]
+  [StorableClass]
+  public class IntegerDecExpression : StatelessExpression {
+    public IntegerDecExpression() { }
+    [StorableConstructor]
+    protected IntegerDecExpression(bool deserializing) : base(deserializing) { }
+
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      return interpreter.IntegerStack.IsEmpty;
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      interpreter.IntegerStack.Top -= 1;
+    }
+  }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs	(revision 15017)
@@ -69,5 +69,5 @@
       var index = interpreter.CustomExpressions.Keys.Count == 1
         ? 0
-        : interpreter.Random.Next(0, interpreter.CustomExpressions.Keys.Count - 1);
+        : interpreter.Random.Next(0, interpreter.CustomExpressions.Keys.Count);
 
       var state = interpreter.CustomExpressions.Keys.ElementAt(index);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs	(revision 15017)
@@ -84,5 +84,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.POP")]
+  [PushExpression(StackTypes.Exec, "EXEC.POP", execIn: 1)]
   public class ExecPopExpression : PopExpression<Expression> {
     public ExecPopExpression() { }
@@ -149,5 +149,5 @@
   [StorableClass]
   [PushExpression(StackTypes.IntegerVector, "INTEGER[].POP")]
-  public class IntegerVectorPopExpression : PopExpression<List<long>> {
+  public class IntegerVectorPopExpression : PopExpression<IReadOnlyList<long>> {
     public IntegerVectorPopExpression() { }
     [StorableConstructor]
@@ -165,5 +165,5 @@
   [StorableClass]
   [PushExpression(StackTypes.FloatVector, "FLOAT[].POP")]
-  public class FloatVectorPopExpression : PopExpression<List<double>> {
+  public class FloatVectorPopExpression : PopExpression<IReadOnlyList<double>> {
     public FloatVectorPopExpression() { }
     [StorableConstructor]
@@ -181,5 +181,5 @@
   [StorableClass]
   [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].POP")]
-  public class BooleanVectorPopExpression : PopExpression<List<bool>> {
+  public class BooleanVectorPopExpression : PopExpression<IReadOnlyList<bool>> {
     public BooleanVectorPopExpression() { }
     [StorableConstructor]
@@ -197,5 +197,5 @@
   [StorableClass]
   [PushExpression(StackTypes.StringVector, "STRING[].POP")]
-  public class StringVectorPopExpression : PopExpression<List<string>> {
+  public class StringVectorPopExpression : PopExpression<IReadOnlyList<string>> {
     public StringVectorPopExpression() { }
     [StorableConstructor]
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs	(revision 15017)
@@ -1,6 +1,5 @@
-﻿using System;
-
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using System.Collections.Generic;
+  using System.Globalization;
   using System.Text;
   using Attributes;
@@ -22,5 +21,5 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      interpreter.PrintStack.Push(PushEnvironment.NewLine);
+      interpreter.PrintStack.Push(string.Empty);
     }
   }
@@ -34,8 +33,12 @@
     protected void Eval(IInternalPushInterpreter interpreter, IPushStack<T> stack) {
       var value = stack.Pop().ToString();
-      interpreter.PrintStack.Push(value);
-    }
-
-    protected void EvalVector(IInternalPushInterpreter interpreter, IPushStack<List<T>> vectorStack) {
+
+      if (interpreter.PrintStack.IsEmpty)
+        interpreter.PrintStack.Push(value);
+      else
+        interpreter.PrintStack.Top += value;
+    }
+
+    protected void EvalVector(IInternalPushInterpreter interpreter, IPushStack<IReadOnlyList<T>> vectorStack) {
       var sb = new StringBuilder();
       var vector = vectorStack.Pop();
@@ -92,5 +95,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Print, "PRINT.PRINTEXEC", StackTypes.Exec)]
+  [PushExpression(StackTypes.Print, "PRINT.PRINTEXEC", StackTypes.Exec, execIn: 1)]
   public class ExecPrintExpression : PrintExpression<Expression> {
     public ExecPrintExpression() { }
@@ -119,5 +122,11 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter, interpreter.FloatStack);
+      var value = interpreter.FloatStack.Pop();
+      var str = value.ToString(interpreter.Configuration.FloatStringFormat, CultureInfo.InvariantCulture);
+
+      if (interpreter.PrintStack.IsEmpty)
+        interpreter.PrintStack.Push(str);
+      else
+        interpreter.PrintStack.Top += str;
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs	(revision 15017)
@@ -1,9 +1,15 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using System;
   using System.Collections.Generic;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+  using System.Linq;
+  using Attributes;
+  using Constants;
+  using Data.Pool;
+  using Extensions;
+  using Interpreter;
+  using Persistence.Default.CompositeSerializers.Storable;
+  using Stack;
+
+  [Serializable]
   [StorableClass]
   public abstract class PushExpression<T> : StatefulExpression<T> {
@@ -20,130 +26,187 @@
       stack.Push(State);
     }
-
-    public override string StringRepresentation { get { return State.ToString(); } }
-  }
-
-  [StorableClass]
+  }
+
+  [StorableClass]
+  [Serializable]
+  public abstract class VectorPushExpression<T> : PushExpression<IReadOnlyList<T>> {
+    [StorableConstructor]
+    protected VectorPushExpression(bool deserializing) : base(deserializing) { }
+
+    protected VectorPushExpression(IReadOnlyList<T> state) : base(state, null) { }
+
+    protected override string GetStringRepresentation() {
+      return PushEnvironment.VectorStartSymbolStr +
+             string.Join(PushEnvironment.VectorSeparatorSymbolStr, State) +
+             PushEnvironment.VectorEndSymbolStr;
+    }
+
+    protected override int CalcHashCode() {
+      return State.HashCode();
+    }
+  }
+
+  [StorableClass]
+  [Serializable]
+  [PushExpression(StackTypes.Integer, "INTEGER.PUSH", isHidden: true)]
   public class IntegerPushExpression : PushExpression<long> {
     [StorableConstructor]
     protected IntegerPushExpression(bool deserializing) : base(deserializing) { }
 
+    public static IntegerPushExpression Create(IManagedPool<Expression> statefulExpressionPool, long state) {
+      var expression = (IntegerPushExpression)statefulExpressionPool.Get();
+      expression.State = state;
+
+      return expression;
+    }
+
+    /// <summary>
+    /// Pushes default(long)
+    /// </summary>
+    public IntegerPushExpression() : base(default(long), null) {
+    }
+
+    public IntegerPushExpression(long state)
+      : base(state, null) {
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      Eval(interpreter.IntegerStack);
+    }
+  }
+
+  [StorableClass]
+  [Serializable]
+  [PushExpression(StackTypes.Float, "FLOAT.PUSH", isHidden: true)]
+  public class FloatPushExpression : PushExpression<double> {
+    [StorableConstructor]
+    protected FloatPushExpression(bool deserializing) : base(deserializing) { }
+
+    public static FloatPushExpression Create(IManagedPool<Expression> statefulExpressionPool, double state) {
+      var expression = (FloatPushExpression)statefulExpressionPool.Get();
+      expression.State = state;
+
+      return expression;
+    }
+
+    /// <summary>
+    /// Pushes default(double)
+    /// </summary>
+    public FloatPushExpression() : base(default(double), null) {
+    }
+
+    public FloatPushExpression(double state)
+      : base(state, null) {
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      Eval(interpreter.FloatStack);
+    }
+  }
+
+  [StorableClass]
+  [Serializable]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.PUSH", isHidden: true)]
+  public class BooleanPushExpression : PushExpression<bool> {
+    [StorableConstructor]
+    protected BooleanPushExpression(bool deserializing, object other) : base(deserializing) { }
+
+    public static BooleanPushExpression Create(IManagedPool<Expression> statefulExpressionPool, bool state) {
+      var expression = (BooleanPushExpression)statefulExpressionPool.Get();
+      expression.State = state;
+
+      return expression;
+    }
+
+    /// <summary>
+    /// Pushes default(bool)
+    /// </summary>
+    public BooleanPushExpression() : base(default(bool), null) {
+    }
+
+    public BooleanPushExpression(bool state)
+      : base(state, null) {
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      Eval(interpreter.BooleanStack);
+    }
+  }
+
+  [StorableClass]
+  [Serializable]
+  [PushExpression(StackTypes.Name, "NAME.PUSH", isHidden: true)]
+  public class NamePushExpression : PushExpression<string> {
+    [StorableConstructor]
+    protected NamePushExpression(bool deserializing) : base(deserializing) { }
+    public static NamePushExpression Create(IManagedPool<Expression> statefulExpressionPool, string state) {
+      var expression = (NamePushExpression)statefulExpressionPool.Get();
+      expression.State = state;
+
+      return expression;
+    }
+
+    public NamePushExpression() : base(string.Empty, null) {
+    }
+
+    public NamePushExpression(string state)
+      : base(state, null) {
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      Eval(interpreter.NameStack);
+    }
+  }
+
+  [StorableClass]
+  [Serializable]
+  [PushExpression(StackTypes.Exec, "EXEC.PUSH", isHidden: true)]
+  public class ExecPushExpression : PushExpression<Expression> {
+    [StorableConstructor]
+    protected ExecPushExpression(bool deserializing) : base(deserializing) { }
+    public static ExecPushExpression Create(IManagedPool<Expression> statefulExpressionPool, Expression state) {
+      var expression = (ExecPushExpression)statefulExpressionPool.Get();
+      expression.State = state;
+
+      return expression;
+    }
+
+    private static readonly Expression Noop = ExpressionTable.GetStatelessExpression<ExecNoopExpression>();
+
+    /// <summary>
+    /// Pushes ExecNoop
+    /// </summary>
+    public ExecPushExpression() : base(Noop, null) {
+    }
+
+    public ExecPushExpression(Expression state)
+      : base(state, null) {
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      Eval(interpreter.ExecStack);
+    }
+  }
+
+  [StorableClass]
+  [Serializable]
+  [PushExpression(StackTypes.Char, "CHAR.PUSH", isHidden: true)]
+  public class CharPushExpression : PushExpression<char> {
+    [StorableConstructor]
+    protected CharPushExpression(bool deserializing) : base(deserializing) { }
+
     // not supported so far
-    //public static IntegerPushExpression Create(IManagedPool<Expression> statefulExpressionPool, long state) {
-    //  var expression = (IntegerPushExpression)statefulExpressionPool.Get();
-    //  expression.State = state;
-
-    //  return expression;
-    //}
-
-    public IntegerPushExpression(long state)
-      : base(state, null) {
-    }
-
-    public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter.IntegerStack);
-    }
-  }
-
-  [StorableClass]
-  public class FloatPushExpression : PushExpression<double> {
-    [StorableConstructor]
-    protected FloatPushExpression(bool deserializing) : base(deserializing) { }
-
-    // not supported so far
-    //public static FloatPushExpression Create(IManagedPool<Expression> statefulExpressionPool, double state) {
-    //  var expression = (FloatPushExpression)statefulExpressionPool.Get();
-    //  expression.State = state;
-
-    //  return expression;
-    //}
-
-    public FloatPushExpression(double state)
-      : base(state, null) {
-    }
-
-    public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter.FloatStack);
-    }
-  }
-
-  [StorableClass]
-  public class BooleanPushExpression : PushExpression<bool> {
-    [StorableConstructor]
-    protected BooleanPushExpression(bool deserializing, object other) : base(deserializing) { }
-
-    // not supported so far
-    //public static BooleanPushExpression Create(IManagedPool<Expression> statefulExpressionPool, bool state) {
-    //  var expression = (BooleanPushExpression)statefulExpressionPool.Get();
-    //  expression.State = state;
-
-    //  return expression;
-    //}
-
-    public BooleanPushExpression(bool state)
-      : base(state, null) {
-    }
-
-    public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter.BooleanStack);
-    }
-  }
-
-  [StorableClass]
-  public class NamePushExpression : PushExpression<string> {
-    [StorableConstructor]
-    protected NamePushExpression(bool deserializing) : base(deserializing) { }
-
-    // not supported so far
-    //public static NamePushExpression Create(IManagedPool<Expression> statefulExpressionPool, string state) {
-    //  var expression = (NamePushExpression)statefulExpressionPool.Get();
-    //  expression.State = state;
-
-    //  return expression;
-    //}
-
-    public NamePushExpression(string state)
-      : base(state, null) {
-    }
-
-    public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter.NameStack);
-    }
-  }
-
-  [StorableClass]
-  public class ExecPushExpression : PushExpression<Expression> {
-    [StorableConstructor]
-    protected ExecPushExpression(bool deserializing) : base(deserializing) { }
-
-    // not supported so far
-    //public static ExecPushExpression Create(IManagedPool<Expression> statefulExpressionPool, Expression state) {
-    //  var expression = (ExecPushExpression)statefulExpressionPool.Get();
-    //  expression.State = state;
-
-    //  return expression;
-    //}
-
-    public ExecPushExpression(Expression state)
-      : base(state, null) {
-    }
-
-    public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter.ExecStack);
-    }
-  }
-
-  [StorableClass]
-  public class CharPushExpression : PushExpression<char> {
-    [StorableConstructor]
-    protected CharPushExpression(bool deserializing) : base(deserializing) { }
-
-    // not supported so far
-    //public static CharPushExpression Create(IManagedPool<Expression> statefulExpressionPool, char state) {
-    //  var expression = (CharPushExpression)statefulExpressionPool.Get();
-    //  expression.State = state;
-
-    //  return expression;
-    //}
+    public static CharPushExpression Create(IManagedPool<Expression> statefulExpressionPool, char state) {
+      var expression = (CharPushExpression)statefulExpressionPool.Get();
+      expression.State = state;
+
+      return expression;
+    }
+
+    /// <summary>
+    /// Pushes default(char)
+    /// </summary>
+    public CharPushExpression() : base(default(char), null) {
+    }
 
     public CharPushExpression(char state)
@@ -151,4 +214,8 @@
     }
 
+    protected override string GetStringRepresentation() {
+      return PushEnvironment.CharSymbol + State.Printify() + PushEnvironment.CharSymbol;
+    }
+
     public override void Eval(IInternalPushInterpreter interpreter) {
       Eval(interpreter.CharStack);
@@ -157,15 +224,26 @@
 
   [StorableClass]
+  [Serializable]
+  [PushExpression(StackTypes.String, "STRING.PUSH", isHidden: true)]
   public class StringPushExpression : PushExpression<string> {
     [StorableConstructor]
     protected StringPushExpression(bool deserializing) : base(deserializing) { }
 
-    // not supported so far
-    //public static StringPushExpression Create(IManagedPool<Expression> statefulExpressionPool, string state) {
-    //  var expression = (StringPushExpression)statefulExpressionPool.Get();
-    //  expression.State = state;
-
-    //  return expression;
-    //}
+    public static StringPushExpression Create(IManagedPool<Expression> statefulExpressionPool, string state) {
+      var expression = (StringPushExpression)statefulExpressionPool.Get();
+      expression.State = state;
+
+      return expression;
+    }
+
+    /// <summary>
+    /// Pushes String.Empty
+    /// </summary>
+    public StringPushExpression() : base(string.Empty, null) {
+    }
+
+    protected override string GetStringRepresentation() {
+      return PushEnvironment.StringSymbol + State + PushEnvironment.StringSymbol;
+    }
 
     public StringPushExpression(string state)
@@ -179,18 +257,27 @@
 
   [StorableClass]
-  public class IntegerVectorPushExpression : PushExpression<List<long>> {
+  [Serializable]
+  [PushExpression(StackTypes.IntegerVector, "INTEGER[].PUSH", isHidden: true)]
+  public class IntegerVectorPushExpression : VectorPushExpression<long> {
     [StorableConstructor]
     protected IntegerVectorPushExpression(bool deserializing) : base(deserializing) { }
 
-    // not supported so far
-    //public static IntegerVectorPushExpression Create(IManagedPool<Expression> statefulExpressionPool, List<long> state) {
-    //  var expression = (IntegerVectorPushExpression)statefulExpressionPool.Get();
-    //  expression.State = state;
-
-    //  return expression;
-    //}
-
-    public IntegerVectorPushExpression(List<long> state)
-      : base(state, null) {
+    public static IntegerVectorPushExpression Create(IManagedPool<Expression> statefulExpressionPool, IReadOnlyList<long> state) {
+      var expression = (IntegerVectorPushExpression)statefulExpressionPool.Get();
+      expression.State = state;
+
+      return expression;
+    }
+
+    [NonSerialized]
+    private static readonly long[] EmptyState = new long[0];
+
+    /// <summary>
+    /// Pushes long[0]
+    /// </summary>
+    public IntegerVectorPushExpression() : base(EmptyState) {
+    }
+
+    public IntegerVectorPushExpression(IReadOnlyList<long> state) : base(state) {
     }
 
@@ -201,19 +288,27 @@
 
   [StorableClass]
-  public class FloatVectorPushExpression : PushExpression<List<double>> {
+  [Serializable]
+  [PushExpression(StackTypes.FloatVector, "FLOAT[].PUSH", isHidden: true)]
+  public class FloatVectorPushExpression : VectorPushExpression<double> {
     [StorableConstructor]
     protected FloatVectorPushExpression(bool deserializing) : base(deserializing) { }
 
-    // not supported so far
-    //public static FloatVectorPushExpression Create(IManagedPool<Expression> statefulExpressionPool, List<double> state) {
-    //  var expression = (FloatVectorPushExpression)statefulExpressionPool.Get();
-    //  expression.State = state;
-
-    //  return expression;
-    //}
-
-    public FloatVectorPushExpression(List<double> state)
-      : base(state, null) {
-    }
+    public static FloatVectorPushExpression Create(IManagedPool<Expression> statefulExpressionPool, IReadOnlyList<double> state) {
+      var expression = (FloatVectorPushExpression)statefulExpressionPool.Get();
+      expression.State = state;
+
+      return expression;
+    }
+
+    [NonSerialized]
+    private static readonly double[] EmptyState = new double[0];
+
+    /// <summary>
+    /// Pushes double[0]
+    /// </summary>
+    public FloatVectorPushExpression() : base(EmptyState) {
+    }
+
+    public FloatVectorPushExpression(IReadOnlyList<double> state) : base(state) { }
 
     public override void Eval(IInternalPushInterpreter interpreter) {
@@ -223,19 +318,27 @@
 
   [StorableClass]
-  public class BooleanVectorPushExpression : PushExpression<List<bool>> {
+  [Serializable]
+  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].PUSH", isHidden: true)]
+  public class BooleanVectorPushExpression : VectorPushExpression<bool> {
     [StorableConstructor]
     protected BooleanVectorPushExpression(bool deserializing) : base(deserializing) { }
 
-    // not supported so far
-    //public static BooleanVectorPushExpression Create(IManagedPool<Expression> statefulExpressionPool, List<bool> state) {
-    //  var expression = (BooleanVectorPushExpression)statefulExpressionPool.Get();
-    //  expression.State = state;
-
-    //  return expression;
-    //}
-
-    public BooleanVectorPushExpression(List<bool> state)
-      : base(state, null) {
-    }
+    public static BooleanVectorPushExpression Create(IManagedPool<Expression> statefulExpressionPool, IReadOnlyList<bool> state) {
+      var expression = (BooleanVectorPushExpression)statefulExpressionPool.Get();
+      expression.State = state;
+
+      return expression;
+    }
+
+    [NonSerialized]
+    private static readonly bool[] EmptyState = new bool[0];
+
+    /// <summary>
+    /// Pushes bool[0]
+    /// </summary>
+    public BooleanVectorPushExpression() : base(EmptyState) {
+    }
+
+    public BooleanVectorPushExpression(IReadOnlyList<bool> state) : base(state) { }
 
     public override void Eval(IInternalPushInterpreter interpreter) {
@@ -245,19 +348,33 @@
 
   [StorableClass]
-  public class StringVectorPushExpression : PushExpression<List<string>> {
+  [Serializable]
+  [PushExpression(StackTypes.StringVector, "STRING[].PUSH", isHidden: true)]
+  public class StringVectorPushExpression : VectorPushExpression<string> {
     [StorableConstructor]
     protected StringVectorPushExpression(bool deserializing) : base(deserializing) { }
 
-    // not supported so far
-    //public static StringVectorPushExpression Create(IManagedPool<Expression> statefulExpressionPool, List<string> state) {
-    //  var expression = (StringVectorPushExpression)statefulExpressionPool.Get();
-    //  expression.State = state;
-
-    //  return expression;
-    //}
-
-    public StringVectorPushExpression(List<string> state)
-      : base(state, null) {
-    }
+    public static StringVectorPushExpression Create(IManagedPool<Expression> statefulExpressionPool, IReadOnlyList<string> state) {
+      var expression = (StringVectorPushExpression)statefulExpressionPool.Get();
+      expression.State = state;
+
+      return expression;
+    }
+
+    [NonSerialized]
+    private static readonly string[] EmptyState = new string[0];
+
+    /// <summary>
+    /// Pushes string[0]
+    /// </summary>
+    public StringVectorPushExpression() : base(EmptyState) {
+    }
+
+    protected override string GetStringRepresentation() {
+      return PushEnvironment.VectorStartSymbolStr +
+             string.Join(PushEnvironment.VectorSeparatorSymbolStr, State.Select(str => PushEnvironment.StringSymbol + str + PushEnvironment.StringSymbol)) +
+             PushEnvironment.VectorEndSymbolStr;
+    }
+
+    public StringVectorPushExpression(IReadOnlyList<string> state) : base(state) { }
 
     public override void Eval(IInternalPushInterpreter interpreter) {
